/*
 *	main.c
 *
 *	WSGvC[
 *
 *	* Sun Feb 15 15:01:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
//#define QUICK_REPEAT_DELAY	SEC(0.25)
#define QUICK_REPEAT_DELAY	SEC(0.5)

/* XvCg`BKvɉăCN[hĂBsprite.h̕ҏWKvłB */
//#include "sprite.h"
//#define DEFINE_SPRITE
//#include "sprite.h"
//#undef  DEFINE_SPRITE

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		10			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

//extern const unsigned char PAT[];
//extern const unsigned char BG[];
//TEXTURE pat;
//TEXTURE bg;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void run();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	//turbo(1); /* S48MHz[h */
	turbo(7); /* 48MHz/1WAIT */
	srand(pceTimerGetCount());
	/* rbg}bvB */
	//texture_init(&pat, PAT);
	//texture_init(&bg, BG);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		//if(joy & TRG_START) {
		if(0) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	
 ****************************************************************************/

DRIVER g_driver;

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	}bs[
 ****************************************************************************/

const ROM mappy_program_roms[] = {
	{ "mp1_4.1k", 0xe000, 0x2000, 0x8182dd5b },
};
const ROM mappy_wavetable_roms[] = {
	{ "mp1-3.3m", 0x0000, 0x0100, 0x16a9166a },
};
void mappy_init(DRIVER* driver) {
	unsigned char* mem;

	/* `FbNTgbvׂB */
	mem = &driver->mem[0xe00f];
	mem[0] = 0x12;	//NOP
	mem[1] = 0x12;	//NOP
	mem[2] = 0x12;	//NOP
	mem[3] = 0x12;	//NOP
	mem[4] = 0x12;	//NOP
	mem[5] = 0x12;	//NOP

	/* IRQ҂[vCWAIɕύXB */
	mem = &driver->mem[0xe052];
	mem[0] = 0x3c;	//CWAI #$FF
	mem[1] = 0xff;
	mem[2] = 0x12;	//NOP
	mem[3] = 0x12;	//NOP
	mem[4] = 0x12;	//NOP
}
const ROMSET mappy_romset = {
	1983,
	"}bs[",
	"mappy.zip",
	mappy_program_roms,
	sizeof mappy_program_roms / sizeof(ROM),
	mappy_wavetable_roms,
	sizeof mappy_wavetable_roms / sizeof(ROM),
	23,
	mappy_init,
};

/****************************************************************************
 *	hA[K̓
 ****************************************************************************/

const ROM todruaga_program_roms[] = {
	{ "td1_4.1k", 0xe000, 0x2000, 0xae9d06d9 },
};
const ROM todruaga_wavetable_roms[] = {
	{ "td1-3.3m", 0x0000, 0x0100, 0x07104c40 },
};
void todruaga_init(DRIVER* driver) {
	unsigned char* mem;

	/* IRQ҂[vCWAIɕύXB */
	mem = &driver->mem[0xe431];
	mem[0] = 0x3c;	//CWAI #$FF
	mem[1] = 0xff;
	mem[2] = 0x12;	//NOP
	mem[3] = 0x12;	//NOP
}
const ROMSET todruaga_romset = {
	1984,
	"hA[K̓",
	"todruaga.zip",
	todruaga_program_roms,
	sizeof todruaga_program_roms / sizeof(ROM),
	todruaga_wavetable_roms,
	sizeof todruaga_wavetable_roms / sizeof(ROM),
	32,
	todruaga_init,
};

/****************************************************************************
 *	gX
 ****************************************************************************/

const ROM motos_program_roms[] = {
	{ "mo1_4.1k", 0xe000, 0x2000, 0x55e45d21 },
};
const ROM motos_wavetable_roms[] = {
	{ "mo1-3.3m", 0x0000, 0x0100, 0x2accdfb4 },
};
void motos_init(DRIVER* driver) {
	unsigned char* mem;

	/* MainCPUSoundCPU[`ւ̎nߑ҂ׂB */
	mem = &driver->mem[0xe005];
	mem[0] = 0x12;	//NOP
	mem[1] = 0x12;	//NOP

	/* MainCPUSoundCPU[`ւ̏Iߑ҂ׂB */
	mem = &driver->mem[0xe05b];
	mem[0] = 0x12;	//NOP
	mem[1] = 0x12;	//NOP

	/* IRQ҂[vCWAIɕύXB */
	mem = &driver->mem[0xe46c];
	mem[0] = 0x3c;	//CWAI #$FF
	mem[1] = 0xff;
	mem[2] = 0x12;	//NOP
	mem[3] = 0x12;	//NOP
}
const ROMSET motos_romset = {
	1985,
	"gX",
	"motos.zip",
	motos_program_roms,
	sizeof motos_program_roms / sizeof(ROM),
	motos_wavetable_roms,
	sizeof motos_wavetable_roms / sizeof(ROM),
	26,
	motos_init,
};

/****************************************************************************
 *	
 ****************************************************************************/

const ROMSET* romset_list[] = {
	&mappy_romset,
	&todruaga_romset,
	&motos_romset,
};
#define ROMSET_COUNT	(sizeof romset_list / sizeof *romset_list)

/****************************************************************************
 *	run
 ****************************************************************************/

#define MAX_DISP	7

void
run()
{
	DRIVER* driver = &g_driver;
	M6809* m6809 = &driver->m6809;
	unsigned char* mem = driver->mem;
	WSG* wsg = &driver->wsg;
	unsigned char* wavetable = driver->wavetable;
	//
	int i_file;
	const ROMSET* romset;

	i_file = 0;
	for(;;) {
		/* t@CIB */
		i_file = file_sel(driver, i_file);
		romset = romset_list[i_file];

		/* ROMǂݍ݁B */
		memset(driver, 0, sizeof(DRIVER));
		if(rom_load(romset->file, romset->program_roms,   romset->num_program_roms,   mem      ) != 0
		|| rom_load(romset->file, romset->wavetable_roms, romset->num_wavetable_roms, wavetable) != 0) {
			/*        012345678901234567890123 */
			err_disp("ROM̧ٓǍݎsł");
			continue;
		}

		/* ʂ̏B */
		romset->init(driver);

		/* M6809AWSGZbgB */
		m6809_reset(m6809, NULL, m6809_write);
		wsg_reset(wsg, WSG_CLOCK, wavetable);

		/* [`̃G~[VsB */
		while(!m6809->wait) {
			m6809_run(m6809, M6809_CLOCK);
		}

		/* Xg[~OĐJnB */
		stream_play(WSGBUFLEN, stream_callback, (int)driver);

		/* gbNIB */
		track_sel(driver, romset);

		/* Xg[~OĐ~B */
		stream_stop();
	}
}

int
file_sel(DRIVER* driver, int cursel)
{
	int curtop = 0;
	int prevsel = -1; /* ͋` */
	int prevtop = -1; /* ͋` */
	//
	int c, i, j, x, y, w;
	const ROMSET* romset;
	const char* s;

	for(;;) {
		schedule();

		/* I? */
		if(joy & TRG_SELECT) exit(0);

		/* t@CIύX? */
		if(joy & TRG_UP && cursel > 0               ) cursel--;
		if(joy & TRG_DN && cursel < ROMSET_COUNT - 1) cursel++;
		if(joy & TRG_LF) { cursel -= MAX_DISP; if(cursel < 0               ) cursel = 0;                }
		if(joy & TRG_RI) { cursel += MAX_DISP; if(cursel > ROMSET_COUNT - 1) cursel = ROMSET_COUNT - 1; }
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĕ`? */
		if(cursel != prevsel || curtop != prevtop) {
			prevsel = cursel;
			prevtop = curtop;
			surface_clear(&surface, 0);

			/* ROMZbgXg\B */
			y = 12;
			for(i = 0; i < MAX_DISP + 1; i++) {
				j = curtop + i;
				if(j > ROMSET_COUNT - 1) break;
				romset = romset_list[j];
				if(j == cursel) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 10 + 1, 2);
					c = 0;
				} else {
					c = 2;
				}
				if(!romset->file) c = 1; /* Ή */
				render_printf(&render, 4, y, 0x80, c, "%-20s%4d", romset->name, romset->year);
				y += 10;
			}

			/* ^Cg\B */
			s = "WSG Player/6809";
			w = strlen(s) * 5;
			x = (DISP_X - w) / 2;
			render_rectangle_fill(&render, 0, 0, DISP_X, 11, 3);
			render_line(&render, 0        , 4, x - 4 , 4, 0);
			render_line(&render, x + w + 4, 4, DISP_X, 4, 0);
			render_line(&render, 0        , 6, x - 4 , 6, 0);
			render_line(&render, x + w + 4, 6, DISP_X, 6, 0);
			render_string(&render, x, 1, s, 0x80, 0);
		}

		/* Im? */
		if(joy & TRG_A) {
			romset = romset_list[cursel];
			if(romset->file) break; /* Ή */
		}
	}

	return cursel;
}

void
track_sel(DRIVER* driver, const ROMSET* romset)
{
	int cursel = 0;
	int curtop = 0;
	int prevsel = -1; /* ͋` */
	int prevtop = -1; /* ͋` */
	int playing = -1;

	int c, i, j, x, y, w;
	const char* s;

	for(;;) {
		schedule();

		/* I? */
		if(joy & TRG_SELECT) exit(0);

		/* t@CIύX? */
		if(joy & TRG_UP && cursel > 0                     ) cursel--;
		if(joy & TRG_DN && cursel < romset->num_tracks - 1) cursel++;
		if(joy & TRG_LF) { cursel -= MAX_DISP; if(cursel < 0                     ) cursel = 0;                      }
		if(joy & TRG_RI) { cursel += MAX_DISP; if(cursel > romset->num_tracks - 1) cursel = romset->num_tracks - 1; }
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĕ`? */
		if(cursel != prevsel || curtop != prevtop) {
			prevsel = cursel;
			prevtop = curtop;
			surface_clear(&surface, 0);

			/* ROMZbgXg\B */
			y = 12;
			for(i = 0; i < MAX_DISP + 1; i++) {
				j = curtop + i;
				if(j > romset->num_tracks - 1) break;
				if(j == cursel) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 10 + 1, 2);
					c = 0;
				} else {
					c = 2;
				}
				if(j == playing) c++;
				render_printf(&render, 4, y, 0x80, c, "TRACK %2d", j + 1);
				y += 10;
			}

			/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
			/* ^Cg\B */
			s = romset->name;
			w = strlen(s) * 5;
			x = (DISP_X - w) / 2;
			render_rectangle_fill(&render, 0, 0, DISP_X, 11, 3);
			render_line(&render, 0        , 4, x - 4 , 4, 0);
			render_line(&render, x + w + 4, 4, DISP_X, 4, 0);
			render_line(&render, 0        , 6, x - 4 , 6, 0);
			render_line(&render, x + w + 4, 6, DISP_X, 6, 0);
			render_string(&render, x, 1, s, 0x80, 0);
		}

		/* tJn? */
		if(joy & TRG_A) {
			driver_play(driver, romset, cursel);
			playing = cursel;
			prevsel = -1; /* ĕ` */
			prevtop = -1; /* ĕ` */
		}

		/* t~? */
		if(joy & TRG_B) break;
	}
}

void
driver_play(DRIVER* driver, const ROMSET* romset, int i_track)
{
	unsigned char* mem = driver->mem;

	/* ܂mɒ~B */
	driver_stop(driver, romset);
DI;
	/* tR}hi[B */
	mem[0x40 + i_track] = 1;
EI;
}

void
driver_stop(DRIVER* driver, const ROMSET* romset)
{
	M6809* m6809 = &driver->m6809;
	unsigned char* mem = driver->mem;

DI;
	/* tR}hNAB */
	memset(&mem[0x40], 0, romset->num_tracks);

	/* ~҂B */
	while(!m6809->wait) m6809_run(m6809, M6809_CLOCK);	/* IRQ҂Ԃ܂Ŏs */
	m6809_irq(m6809);					/* IRQs */
	while(!m6809->wait) m6809_run(m6809, M6809_CLOCK);	/* Œ~͂ł */
EI;
}

int
stream_callback(short wbuff[/*WSGBUFLEN*/], int param)
{
	static unsigned char fram4_save[0x200];  /* rs`shbII */
	memcpy(fram4_save, (void*)0xe00, 0x200); /* 0xe00`0xfffޔ */
	driver_mix2((DRIVER*)param, wbuff);
	memcpy((void*)0xe00, fram4_save, 0x200); /* 0xe00`0xfff */
	return 0;
}

/* ~LVORAMX^bNœ삳邽߂Wrapper */
asm("
	.code
	.align 1
driver_mix2:
	pushn %r0
	ld.w %r0, %sp		; X^bNޔ
	xld.w %r10, 0x1000	; 0x0e00`0x1000ɃX^bNؑ
	ld.w %sp, %r10
	call driver_mix
	ld.w %sp, %r0		; X^bN
	popn %r0
	ret
");

void
driver_mix(DRIVER* driver, short wbuff[/*WSGBUFLEN*/])
{
	int cnt1 = WSGBUFLEN;	/* cTv */
	int cnt2;

	ASSERT(M6809_CLOCK >= SPEAKER_FREQUENCY);
	do {
		/* 񊄂荞ݔ܂ł̎cTCNŁATv~LVOł邩? */
		cnt2 = (driver->irq_cycle * SPEAKER_FREQUENCY + M6809_CLOCK - 1) / M6809_CLOCK;
		if(cnt2 > cnt1) cnt2 = cnt1;

		/* ~LVOB */
		wsg_mix(&driver->wsg, wbuff, cnt2);
		wbuff += cnt2;
		cnt1 -= cnt2;

		/* 񊄂荞ݔ܂ł̎cTCN炵āA0ɂȂ犄荞ݏB */
		driver->irq_cycle -= cnt2 * M6809_CLOCK / SPEAKER_FREQUENCY;
		while(driver->irq_cycle <= 0) {
			driver->irq_cycle += IRQ_INTERVAL;
			m6809_irq(&driver->m6809);
			m6809_run(&driver->m6809, M6809_CLOCK/*ňł1bȓɂ͊Ɖ*/);
		}
	} while(cnt1);
}

